#include <iostream>
#include <assert.h>
#include <deque>
#include <stdio.h>
#include <string.h>

using namespace std;

int dx[] = {1, 0, -1, 0};
int dy[] = {0, 1, 0, -1};

int main()
{
	freopen("heroes.in", "rt", stdin);
	//freopen("heroes.out", "wt", stdout);

	int testn;
	scanf("%d", &testn);

	for (int testi = 0; testi < testn; testi++)
	{
		int n, m;
		scanf("%d %d\n", &n, &m);
		assert(n >= 1 && n <= 20);
		assert(m >= 1 && m <= 20);
		
		char a[32][32] = {0};
		for (int i = 0; i < n + 2; i++)
		{
			a[i][0] = a[i][m + 1] = '1';
		}
		for (int j = 0; j < m + 2; j++)
		{
			a[0][j] = a[n + 1][j] = '1';
		}


		for (int i = 0; i < n; i++)
		{
			char str[32] = {0};
			gets(str);
			assert(strlen(str) == m);
			//  
			//assert(str[0] == '1' && str[m - 1] == '1');

			for (int j = 0; j < m; j++)
			{
				assert(str[j] == '1' || str[j] == '0');
				a[i + 1][j + 1] = str[j];
			}
		}

		int qx, qy, time;
		scanf("%d %d %d\n", &qx, &qy, &time);
		assert(qx >= 1 && qx <= n);
		assert(qy >= 1 && qy <= m);
		assert(a[qx][qy] == '0');
		assert(time >= 1 <= 1000);

		int result = 0;

		for (int h = 0; h < 4; h++)
		{
			int xx, yy, count;
			scanf("%d %d %d\n", &xx, &yy, &count);
			assert(xx >= 1 && xx <= n);
			assert(yy >= 1 && yy <= m);
			assert(a[xx][yy] == '0');
			assert(count >= 1 && count <= 1000);
			//      
			//assert(xx != qx && yy != qy);

			int steps[32][32] = {0};
			steps[xx][yy] = 1;

			deque<pair<int, int> > path;
			path.push_back(make_pair<int, int>(xx, yy));

			while(!path.empty())
			{
				pair<int, int> pos = path.front();
				path.pop_front();

				if (pos.first == qx && pos.second == qy)
					break;

				for (int i = 0; i < 4; i++)
				{
					int x = pos.first + dx[i];
					int y = pos.second + dy[i];
					if (a[x][y] == '0' && steps[x][y] == 0)
					{
						steps[x][y] = steps[pos.first][pos.second] + 1;
						path.push_back(make_pair<int, int>(x, y));
					}
				}
			}

			if (steps[qx][qy] > 0 && (steps[qx][qy] - 1) <= time)
			{
				result += count;
			}
		}

		printf("%d\n", result);
	}

	return 0;
}